#line 1 "C:/Users/Pavel/Google /Projects/Microchip/PCF8574_LCD/SW/LCDv1.c"
#line 1 "c:/users/pavel/google /projects/microchip/pcf8574_lcd/sw/lcdv1.h"
#line 20 "c:/users/pavel/google /projects/microchip/pcf8574_lcd/sw/lcdv1.h"
void LCD_init(void);
void LCD_SetPosition( unsigned char  row,  unsigned char  colum);
void LCD_BackLight (unsigned char State);
void LCD_PrintChar(char Data);
void LCD_PrintString(char * string);
void LCD_PrintStringLen(char * string, unsigned char Len);
void LCD_PrintHEX_Byte (unsigned char HexValue);
void LCD_PrintValue_uChar (unsigned char Value);
void LCD_PrintValue_uLong (unsigned long Value);
void LCD_PrintValue_sChar (signed char Value);
void LCD_PrintValue_sLong (signed long Value);
#line 1 "c:/users/pavel/google /projects/microchip/pcf8574_lcd/sw/pcf8574.h"

void PCF8574_Init (void);
void PCF8574_Write (unsigned char Data);
#line 1 "c:/users/pavel/google /projects/microchip/pcf8574_lcd/sw/strings.h"




void uLongToStr (unsigned long Value, char * String);
void sLongToStr (signed long Value, char * String);
void uCharToStr (unsigned char Value, char * String);
void sCharToStr (signed char Value, char * String);
void FillString (char * Data, char * String);
void ClearString (char * String, char Len, char Data);
void StringMoveLeft (char * String, char Len);
void StringMoveRight (char * String, char Len);
 unsigned char  StringLen (char * String);
void ValueToStringHEX_Byte (unsigned char Value, char * String);
void ValueToStringHEX_Word (unsigned int Value, char * String);
void ValueToStringHEX_Long (unsigned long Value, char * String);
signed char uCharTosChar (unsigned char Value);
signed int uIntTosInt (unsigned int Value);
signed long uLongTosLong (unsigned long Value);
unsigned char sCharTouChar (signed char Value);
#line 11 "C:/Users/Pavel/Google /Projects/Microchip/PCF8574_LCD/SW/LCDv1.c"
unsigned char SPI_DAT=0;
void LCD_Write( unsigned char  Dat);
void LCD_Send_Cmd( unsigned char  CMD);
void LCD_WriteData( unsigned char  dat);

void LCD_init(void)
{
 Delay_ms(17);
 LCD_Write(0x30);
 Delay_ms(1);
 LCD_Write(0x30);
 Delay_ms(1);
 LCD_Write(0x30);
 Delay_ms(1);
 LCD_Write(0x20);

 LCD_Send_Cmd(0x28);
 LCD_Send_Cmd(0x10);
 LCD_Send_Cmd(0x01);
 LCD_Send_Cmd(0x0F);

 LCD_Send_Cmd( 0x0C );
 LCD_Send_Cmd( 0x01 );
 Delay_ms(10);
}

void LCD_Write( unsigned char  Dat)
{
 SPI_DAT&=( (1<<0) | (1<<3) );
 SPI_DAT|=(Dat& 0xF0 )| (1<<2) ;
 PCF8574_Write(SPI_DAT);
 Delay_us(5);
 SPI_DAT&=~ (1<<2) ;
 PCF8574_Write(SPI_DAT);
 Delay_us(5);
}
void LCD_Send_Cmd( unsigned char  CMD)
{
 Delay_ms(5);
 SPI_DAT&=~ (1<<0) ;
 LCD_Write((CMD&0xF0));
 LCD_Write(((CMD&0x0F)<<4));
}

void LCD_SetPosition( unsigned char  row,  unsigned char  colum)
{
  unsigned char  position = 0x80;
 if (row > 0) { position |= 0x40;}
 LCD_Send_Cmd(position | colum);
}

void LCD_WriteData( unsigned char  dat)
{
 Delay_us(50);
 SPI_DAT|= (1<<0) ;
 LCD_Write((dat&0xF0));
 LCD_Write(((dat&0x0F)<<4));
}

void LCD_BackLight (unsigned char State)
{
 if (State) SPI_DAT|= (1<<3) ;
 else SPI_DAT&=~ (1<<3) ;
}

void LCD_PrintChar(char Data)
{
 if (Data=='\n') LCD_Send_Cmd(0x80|0x40);
 else LCD_WriteData(Data);
}

void LCD_PrintString(char * string)
{
 while (*string) LCD_PrintChar(*string++);
}

void LCD_PrintStringLen(char * string, unsigned char Len)
{
 while (Len--) LCD_PrintChar(*string++);
}

void LCD_PrintHEX_Byte (unsigned char HexValue)
{
 char String[5]="0x";
 ClearString(String+2,3,0);
 ValueToStringHEX_Byte(HexValue, String+2);
 LCD_PrintString(String);
}

void LCD_PrintValue_uChar (unsigned char Value)
{
 char String[4];
 ClearString(String,4,0);
 uCharToStr(Value, String);
 LCD_PrintString(String);
}

void LCD_PrintValue_uLong (unsigned long Value)
{
 char String[11];
 ClearString(String,11,0);
 uLongToStr(Value, String);
 LCD_PrintString(String);
}

void LCD_PrintValue_sChar (signed char Value)
{
 char String[5];
 ClearString(String,5,0);
 sCharToStr(Value, String);
 LCD_PrintString(String);
}

void LCD_PrintValue_sLong (signed long Value)
{
 char String[12];
 ClearString(String,12,0);
 sLongToStr(Value, String);
 LCD_PrintString(String);
}
